"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const take_1 = require("./take");
const skip_1 = require("./skip");
function slice(source, start, end) {
    if (start === undefined && end === undefined) {
        return source;
    }
    if (start !== undefined && end === undefined) {
        return skip_1.skip(source, check(start, 'start'));
    }
    if (start === undefined && end !== undefined) {
        return take_1.take(source, check(end, 'end'));
    }
    if (start !== undefined && start < 0) {
        throw new Error('Invalid start range, use positive index.');
    }
    return skip_1.skip(take_1.take(source, check(end, 'end')), check(start, 'start'));
}
exports.slice = slice;
function check(value, name) {
    if (value < 0) {
        throw new Error(`Invalid ${name} range, use positive index.`);
    }
    return value;
}

//# sourceMappingURL=slice.js.map
