import { AsyncIterableQuery } from './AsyncIterableQuery';
export interface AsyncIterableJoin<T> extends AsyncIterable<T> {
    join<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right: TRight) => TResult): AsyncIterableQuery<TResult>;
    leftJoin<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right?: TRight) => TResult): AsyncIterableQuery<TResult>;
    groupJoin<TKey, TRight, TResult>(other: Iterable<TRight>, leftKeySelector: (element: T, index: number) => TKey, rightKeySelector: (element: TRight, index: number) => TKey, joinSelector: (left: T, right: TRight[]) => TResult): AsyncIterableQuery<TResult>;
}
