import { AsyncIterableJoin } from './AsyncIterableJoin';
import { AsyncIterablePredicate } from './AsyncIterablePredicate';
import { AsyncIterableFilter } from './AsyncIterableFilter';
import { AsyncIterableSet } from './AsyncIterableSet';
import { AsyncIterableTransformation } from './AsyncIterableTransformation';
import { AsyncIterableValue } from './AsyncIterableValue';
export interface AsyncIterableQuery<T> extends AsyncIterableValue<T>, AsyncIterablePredicate<T>, AsyncIterableFilter<T>, AsyncIterableTransformation<T>, AsyncIterableSet<T>, AsyncIterableJoin<T>, AsyncIterable<T> {
    entries(): AsyncIterableQuery<[number, T]>;
    keys(): AsyncIterableQuery<number>;
    values(): AsyncIterableQuery<T>;
    concat(other: T | Promise<T> | Iterable<T> | AsyncIterable<T>): AsyncIterableQuery<T>;
    prepend(other: T | Promise<T> | Iterable<T> | AsyncIterable<T>): AsyncIterableQuery<T>;
}
