import { AsyncIterableQuery } from './AsyncIterableQuery';
export interface AsyncIterableSet<T> extends AsyncIterable<T> {
    distinct(): AsyncIterableQuery<T>;
    distinct<S>(selector: (element: T) => S): AsyncIterableQuery<T>;
    exclude(other: Iterable<T>): AsyncIterableQuery<T>;
    exclude<S>(other: Iterable<T>, selector: (element: T) => S): AsyncIterableQuery<T>;
    intersect(other: Iterable<T>): AsyncIterableQuery<T>;
    intersect<S>(other: Iterable<T>, selector: (element: T) => S): AsyncIterableQuery<T>;
    union(other: AsyncIterable<T>): AsyncIterableQuery<T>;
    union<S>(other: AsyncIterable<T>, selector: (element: T) => S): AsyncIterableQuery<T>;
}
