import { IterableQuery } from 'itiriri';
export interface AsyncIterableValue<T> extends AsyncIterable<T> {
    nth(index: number): Promise<T | undefined>;
    awaitAll(): Promise<IterableQuery<T>>;
    indexOf(element: T): Promise<number>;
    indexOf(element: T, fromIndex: number): Promise<number>;
    findIndex(predicate: (element: T, index: number) => boolean): Promise<number>;
    lastIndexOf(element: T): Promise<number>;
    lastIndexOf(element: T, fromIndex: number): Promise<number>;
    findLastIndex(predicate: (element: T, index: number) => boolean): Promise<number>;
    length(): Promise<number>;
    length(predicate: (element: T, index: number) => boolean): Promise<number>;
    first(): Promise<T | undefined>;
    find(predicate: (element: T, index: number) => boolean): Promise<T | undefined>;
    last(): Promise<T | undefined>;
    findLast(predicate: (element: T, index: number) => boolean): Promise<T | undefined>;
    average(): Promise<number | undefined>;
    average(selector: (element: T, index: number) => number): Promise<number | undefined>;
    min(): Promise<T | undefined>;
    min(compareFn: (element1: T, element2: T) => number): Promise<T | undefined>;
    max(): Promise<T | undefined>;
    max(compareFn: (element1: T, element2: T) => number): Promise<T | undefined>;
    sum(): Promise<number | undefined>;
    sum(selector: (element: T, index: number) => number): Promise<number | undefined>;
    reduce(callback: (accumulator: T, current: T, index: number) => T): Promise<T>;
    reduce<S>(callback: (accumulator: S, current: T, index: number) => S, initialValue: S): Promise<S>;
    forEach(action: (element: T, index: number) => void): Promise<void>;
}
